freeslot("sfx_hryup1", "sfx_hryup2", "sfx_hryup3", "sfx_hryup4", "sfx_conkgl")
freeslot("SPR_HRYU")
freeslot("MT_HURRYUP_PORTAL", "S_HURRYUP_PORTAL", "MT_BLEED_GEM")
freeslot("MT_FROGSWITCH", "S_FROGSWITCH_IDLE", "S_FROGSWITCH_HIT", "S_FROGSWITCH_ACTIVE")
freeslot("MT_OLDSIGN")

COM_AddCommand("dezmodifier", function(p)
	if not p or not p.valid
        CONS_Printf(p, "Ur not in game.")
        return
	end
	if deeznuts == 1 then
	deeznuts = 0
	end
	if deeznuts == 0 then
	deeznuts = 1
	end
end)

local HURRYUP_STATE = {
	portal = nil,
	active = false
}

mobjinfo[MT_HURRYUP_PORTAL] = {
	flags = MF_NOGRAVITY | MF_SPECIAL,
	spawnstate = S_HURRYUP_PORTAL,
	radius = 32*FU,
	height = 64*FU
}

mobjinfo[MT_FROGSWITCH] = {
	flags = MF_SOLID,
	spawnstate = S_FROGSWITCH_IDLE,
	height = 40*FU,
	radius = 12*FU
}

mobjinfo[MT_BLEED_GEM] = {
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT,
	spawnstate = S_INVISIBLE
}

addHook("MapLoad", function ()
	mobjinfo[MT_BLEED_GEM].spawnstate = S_RING
end)

states[S_HURRYUP_PORTAL] = {
	sprite = SPR_HRYU,
	frame = A|FF_FULLBRIGHT,
	tics = -1,
	nextstate = S_HURRYUP_PORTAL
}

states[S_FROGSWITCH_IDLE] = {
	sprite = SPR_HRYU,
	frame = B,
	tics = -1,
	nextstate = S_FROGSWITCH_HIT
}

states[S_FROGSWITCH_HIT] = {
	sprite = SPR_HRYU,
	frame = C,
	tics = TICRATE,
	nextstate = S_FROGSWITCH_ACTIVE
}

states[S_FROGSWITCH_ACTIVE] = {
	sprite = SPR_HRYU,
	frame = D,
	tics = -1,
	nextstate = S_FROGSWITCH_ACTIVE
}



local function shouldHurryUp()
	//if netgame or multiplayer then return false end
	if not consoleplayer or netgame or HurryUpOff == 1 or consoleplayer.skin ~= #skins.conklers then return false end
	if mapheaderinfo[gamemap].bonustype == 1 then return false end
	if CONKLERS_INESCAPABLE[G_BuildMapTitle()] then return false end
	if mapheaderinfo[gamemap].warioinescapable then return false end
	
	--print(G_BuildMapTitle() .. " is escapable")
	
	return true
end

local function getHurryUpMusic()
	return mapheaderinfo[gamemap].warioescapemusic or "HURYUP"
end



local function HurryUp()
	print("HURRY UP")
	HURRYUP_STATE.active = true
	S_StartSound(nil, sfx_hryup1 + P_RandomRange(0,3))
	P_LinedefExecute(221)
	S_ChangeMusic(getHurryUpMusic(), true, consoleplayer, 0, 0, 0, 0)
	mapmusname = getHurryUpMusic()
	//P_SetupLevelSky(34, nil)
	P_SetupLevelSky(605, nil)
	P_SetSkyboxMobj(nil, nil)
	P_StartQuake(7*FRACUNIT, 2100, nil, nil)
	if mapheaderinfo[gamemap].warioescapetime then
		HURRYUP_STATE.timeleft = tonumber(mapheaderinfo[gamemap].warioescapetime)
	elseif CONKLERS_ESCAPE_TIMES[G_BuildMapTitle()] then
		HURRYUP_STATE.timeleft = CONKLERS_ESCAPE_TIMES[G_BuildMapTitle()]
	else
		HURRYUP_STATE.timeleft = 2*leveltime/3
	end
	HURRYUP_STATE.freezetime = 0
end

addHook("PlayerSpawn", function (p)
	if p.warioFinishing then
		p.pflags = $ & ~PF_NOCLIP
	end
	p.warioFinishing = false
	p.warioBleedBeat = 2
end)

addHook("MobjThinker", function (mo)
	mo.rollangle = $ + ANG2
	local targetscale = FU/2
	if HURRYUP_STATE.active then
		targetscale = 5*FU/2
	end
	
	if mo.finishing then
		local fin = mo.finishing
		local p = fin.player
		p.exiting = 5
		p.mo.momx = (mo.x - p.mo.x)/16
		p.mo.momy = (mo.y - p.mo.y)/16
		p.mo.momz = (mo.z - p.mo.z + mo.height / 2)/16
		p.mo.spritexscale = fin.tics*$/TICRATE
		p.mo.spriteyscale = fin.tics*$/TICRATE
		fin.tics = $ - 1
		if fin.tics < 0 then
			fin.tics = 0
			p.exiting = 3
		end
	end
	mo.scale = 6*$/7 + targetscale/7
end, MT_HURRYUP_PORTAL)

addHook("TouchSpecial", function (special, toucher)
	if toucher.type == MT_PLAYER and HURRYUP_STATE.active and not special.finishing then
		special.finishing = {
			player = toucher.player,
			tics = TICRATE
		}
		toucher.player.warioFinishing = true
		toucher.player.pflags = $ | PF_NOCLIP
	end
	return true
end, MT_HURRYUP_PORTAL)

addHook("MapThingSpawn", function (mo, thing)
	if not shouldHurryUp() then return end
	local switch = P_SpawnMobjFromMobj(mo, 0, 0, FU, MT_FROGSWITCH)
	switch.scale = $*2
	mo.fuse = 1
end, MT_SIGN)

addHook("MapThingSpawn", function (mo, thing)
	if not shouldHurryUp() then return end
	local switch = P_SpawnMobjFromMobj(mo, 0, 0, FU, MT_FROGSWITCH)
	switch.scale = $*2
	mo.fuse = 1
end, MT_OLDSIGN)

addHook("PostThinkFrame", function ()
	if not shouldHurryUp() then return end
	--print("hup " .. tostring(HURRYUP_STATE.active))
	for p in players.iterate do
		if not p then continue end
		if (p.cmd.buttons & BT_CUSTOM3)
			or (((p.pflags & PF_FINISHED) or p.exiting) and not p.warioFinishing) then
			p.exiting = 0
			p.pflags = $ & ~(PF_FINISHED | PF_FULLSTASIS)
		end
		if HURRYUP_STATE.active and not p.warioFinishing then
			--print(HURRYUP_STATE.timeleft)
			p.realtime = HURRYUP_STATE.timeleft
			if HURRYUP_STATE.freezetime > 0 then
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
				p.powers[pw_nocontrol] = 2
			end
			if HURRYUP_STATE.timeleft <= 0 then
				if p.warioBleedBeat then
					p.warioBleedBeat = $ - 1
				else
					if p.rings then
						p.rings = $ - 1
						local gem = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_BLEED_GEM)
						local angle = p.drawangle + P_RandomRange(-20, 20)*ANG1/2
						gem.momx = -cos(p.drawangle)*8 + p.mo.momx/2
						gem.momy = -sin(p.drawangle)*8 + p.mo.momy/2
						P_SetObjectMomZ(gem, FU*8 + p.mo.momz*P_MobjFlip(gem)/2)
						S_StartSound(gem, sfx_conkgl)
						gem.colorized = true
						gem.color = SKINCOLOR_RED
						local tmp = gem.scale
						gem.scale = $/2
						gem.destscale = tmp
						gem.scalespeed = $ * 3
						p.warioBleedBeat = 14
					elseif p.playerstate == PST_LIVE then
						P_KillMobj(p.mo)
					end
				end
			end
		end
	end
	if HURRYUP_STATE.active then
		if HURRYUP_STATE.freezetime > 0 then
			HURRYUP_STATE.freezetime = $ - 1
		elseif HURRYUP_STATE.timeleft > 0 then
			HURRYUP_STATE.timeleft = $ - 1
			if HURRYUP_STATE.timeleft <= TICRATE and mapmusname ~= "GEMLOS" then
				print("spooky scary ringloss")
				S_ChangeMusic("GEMLOS", true, consoleplayer, 0, 0, 1000, 500)
				mapmusname = "GEMLOS"
				print("sends spine")
			end
		end
	end
end)

addHook("MapLoad", function ()
	HURRYUP_STATE.active = false
end)

addHook("ThinkFrame", function ()
	if leveltime < 10 then return end
	if not shouldHurryUp() then return end
	if (HURRYUP_STATE.portal and HURRYUP_STATE.portal.valid) then return end
	
	local targetthing = mapthings[0]
	local lowest = 33
	for thing in mapthings.iterate do
		if thing.type < lowest then
			targetthing = thing
			lowest = thing.type
		end
	end
	
	print("poopy " .. tostring(targetthing.type) .. "at" .. 
		tostring(targetthing.x) .. ", " .. tostring(targetthing.y)
	)
	HURRYUP_STATE.portal = P_SpawnMobj(
		targetthing.x*FU,
		targetthing.y*FU,
		targetthing.options>>4 * FU + FU*48,
		MT_HURRYUP_PORTAL
	)
	
	HURRYUP_STATE.portal.z = HURRYUP_STATE.portal.floorz + FU*64
	
	HURRYUP_STATE.portal.scale = 0
end)

addHook("MobjDamage", function (mo)
	if HURRYUP_STATE.active and mo.player then
		local p = mo.player
		if not p.powers[pw_shield] then
			p.powers[pw_shield] = SH_PITY
		end
	end
end)

addHook("MobjThinker", function (mo)
	P_SetObjectMomZ(mo, -gravity, true)
end, MT_BLEED_GEM)

addHook("MusicChange", function (old, new)
	if old:upper() == "HURYUP" and new == mapmusname and HURRYUP_STATE.active then
		return true
	end
end)

addHook("MobjCollide", function (mo, other)
	if other.type ~= MT_PLAYER then return end
	if consoleplayer.skin ~= #skins.conklers then return end
	local zdiff = abs(other.z - mo.z)
	if zdiff >= mo.height and zdiff <= (mo.height + FU*3) then
		if not HURRYUP_STATE.active then
			--make sure the escape can actually happen
			--spiral hill pizza made me add this
			if HURRYUP_STATE.portal and HURRYUP_STATE.portal.valid then
				HurryUp()
				mo.tics = 1
				P_SetObjectMomZ(other, 7*FRACUNIT, true)
				--deeznuts modifier
				//if other.player.modifiers.deeznuts == 1 then
					//SpawnDeezNuts(p)
					//end
			else
				other.player.exiting = TICRATE
				other.player.warioFinishing = true
			end
		end
	end
end, MT_FROGSWITCH)

hud.add(function (v,p)
	local me = p.mo
    if me.skin == CONK_SKIN 
	and p.mo
	and p.mo.valid
	and HURRYUP_STATE.active == true then
		local str = tostring(p.realtime/TICRATE)
		local width = v.levelTitleWidth(str)
		
		local clock = v.cachePatch("CONK_TIMER" .. (leveltime%6)+1)
		v.draw(160-(width/2)-(clock.width)-2,
			10, 
			clock,
			V_SNAPTOTOP|V_PERPLAYER
		)
		
		
		v.drawLevelTitle(160-(width/2),
			10,
			str,
			V_SNAPTOTOP|V_PERPLAYER|V_YELLOWMAP
		)
    end
end, "game")