local TR = TICRATE


rawset(_G,"ConkMenuOpenClose",function(p)
	local menu = p.conk_menu
	if not menu then return end
	if menu.menuinaction
		menu.menuinaction = false
		p.pflags = $ &~PF_FORCESTRAFE		
		return
	end
	
	menu.menuinaction = true
end)

local function btntic(p,tic,enum)
	local btn = p.cmd.buttons
	if btn & enum
		tic = $+1
	else
		tic = 0
	end
	return tic
end

local function menuthinker(p)
	local me = p.mo
	local menu = p.conk_menu
	
	if p.poopyshitstuff == nil
		p.poopyshitstuff = {
			c2 = 0,
			c3 = 0,
			fn = 0,
		}
	end
	
	p.poopyshitstuff.c2 = btntic(p,$,BT_CUSTOM2)
	p.poopyshitstuff.c3 = btntic(p,$,BT_CUSTOM3)
	p.poopyshitstuff.fn = btntic(p,$,BT_FIRENORMAL)
	
	if not menu.menuinaction
		if ((p.poopyshitstuff.c2 >= TR)
		and (p.poopyshitstuff.c3 >= TR)
		and (p.poopyshitstuff.fn >= TR))
			ConkMenuOpenClose(p)
		end
		return
	end
	
	if p.spectator
	or not (me and me.valid)
		ConkMenuOpenClose(p)
		return
	end
	
 	p.powers[pw_nocontrol] = 3
	p.pflags = $ |PF_FULLSTASIS|PF_FORCESTRAFE
	
	if (p.cmd.buttons & BT_CUSTOM1)
		ConkMenuOpenClose(p)
		return
	end
	
	if menu.hintfade > 0 then menu.hintfade = $-1 end
	
	if (p.cmd.forwardmove > 19)
		menu.up = $+1
		menu.down = 0
	else
		menu.up = 0
	end
	if (p.cmd.forwardmove < -19)
		menu.down = $+1
		menu.up = 0
	else
		menu.down = 0
	end
	if (p.cmd.sidemove > 19) and not (menu.up or menu.down)
		menu.right = $+1
		menu.left = 0
		menu.scroll = 0
	else
		menu.right = 0
	end
	if (p.cmd.sidemove < -19) and not (menu.up or menu.down)
		menu.left = $+1
		menu.right = 0
		menu.scroll = 0
	else
		menu.left = 0
	end
	if (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_SPIN)
		menu.jump = $+1
	else
		menu.jump = 0
	end
	
	
	if menu.left == 1
	or menu.left >= TR/2
		if menu.page > 0
			menu.y = 0
			menu.page = $-1
			S_StartSound(nil,sfx_menu1,p)
		end		
	end
	if menu.right == 1
	or menu.right >= TR/2
		if menu.page ~= #CONK_MENU.entries
			menu.y = 0
			menu.page = $+1
			S_StartSound(nil,sfx_menu1,p)
		end
	end
	
	if menu.up == 1
	or menu.up >= TR/2
		if menu.y ~= 0
			menu.y = $-1
			S_StartSound(nil,sfx_menu1,p)
		end
	end
	if menu.down == 1
	or menu.down >= TR/2
		if menu.y ~= #CONK_MENU.entries[menu.page].text-1
			menu.y = $+1
			S_StartSound(nil,sfx_menu1,p)
		end
	end
	if menu.jump == 1
		if CONK_MENU.entries[menu.page].commands
		and CONK_MENU.entries[menu.page].commands[menu.y+1] ~= nil
			
			COM_BufInsertText(p,CONK_MENU.entries[menu.page].commands[menu.y+1])
			S_StartSound(nil,sfx_menu1,p)
		elseif CONK_MENU.entries[menu.page].cvars
		and CONK_MENU.entries[menu.page].cvars[menu.y+1] ~= nil
			local cv = CONK_MENU.entries[menu.page].cvars[menu.y+1]
			local setting = 0
			setting = 1-cv.value
			COM_BufInsertText(p,cv.name.." "..setting)
			S_StartSound(nil,sfx_menu1,p)
			
		end
	end
end

addHook("PreThinkFrame",do
	for p in players.iterate
		if p.conk_menu == nil
			p.conk_menu = {
				menuinaction = false,
				
				--cursor pos
				y = 0,
				page = 0,
				scroll = 0,
				
				--btn
				up = 0,
				down = 0,
				left = 0,
				right = 0,
				jump = 0,
				
				hintfade = 3*TR+18,
			}
		else
			menuthinker(p)
		end
	end
end)

local function drawcosmenu(v,p)
	
	local me = p.mo
	
	local menu = p.conk_menu
	if menu == nil then return end
	if menu.menuinaction == false then return end
	
	local page = CONK_MENU.entries[menu.page]
	
	local function happyshakelol(v,pos,evenless)
		pos = $ or 0
		local s = 5
		local shakex,shakey = v.RandomFixed()/2,v.RandomFixed()/2
		
		local d1 = v.RandomRange(-1,1)
		local d2 = v.RandomRange(-1,1)
		if d1 == 0
			d1 = v.RandomRange(-1,1)
		end
		if d2 == 0
			d2 = v.RandomRange(-1,1)
		end

		shakex = $*s*d1
		shakey = $*s*d2
		
		local oncur = 0
		if pos-1 == menu.y then oncur = FU end
		
		shakex,shakey = FixedDiv($1,2*FU),FixedDiv($2,2*FU)
		shakex,shakey = FixedMul($1,oncur),FixedMul($2,oncur)
		if (evenless)
			shakex,shakey = FixedDiv($1,2*FU),FixedDiv($2,2*FU)		
		end
		
		return shakex,shakey
	end
	
	local pos = {x = 15,y = 15}
	local shakex,shakey = happyshakelol(v)
	
	local pagecolor = SKINCOLOR_GREEN
	if (page.color == "mo.color")
		pagecolor = mo.color
	elseif (page.color == "p.skincolor")
		pagecolor = p.skincolor
	else
		pagecolor = page.color
	end
	
	
	--TODO: transparent box behind text, I CANT SEE IT!
	
	--drawfill my favorite :kindlygimmesummadat:
	v.drawFill(0,0,v.width(),v.height(),
		--even if there is tearing, you wont see the black void
		skincolors[pagecolor].ramp[15]|V_SNAPTOLEFT|V_SNAPTOTOP
	)
	
	--need the scale before the loops
	local s = FU*3/2
	local bgp = v.cachePatch("TA_MENUBG")
	--this will overflow in 15 minutes + some change
	local timer = FixedDiv(leveltime*FU,2*FU) or 1
	local bgoffx = FixedDiv(timer,2*FU)%(bgp.width*s)
	local bgoffy = FixedDiv(timer,2*FU)%(bgp.height*s)
	for i = 0,(v.width()/bgp.width)--+1
		for j = 0,(v.height()/bgp.height)--+1
			--Complicated
			local x = 300
			local y = bgp.height*(j-1)
			local f = V_SNAPTORIGHT|V_SNAPTOTOP|V_70TRANS
			local c = v.getColormap(nil,pagecolor)
			
			v.drawScaled(((x-bgp.width*(i-1)))*s-bgoffx,
				(y)*s+bgoffy,
				s,
				bgp, --v.cachePatch("?"),
				f,
				c
			)
			v.drawScaled(((x-bgp.width*i))*s-bgoffx,
				(y)*s+bgoffy,
				s,
				bgp, --v.cachePatch("?"),
				f,
				c
			)
		end
	end
	
	v.drawScaled((300-pos.x)*FU,pos.y*FU,(FU/2)+(FU/12),
		v.cachePatch("TB_C1"),
		V_SNAPTORIGHT|V_SNAPTOTOP
	)
	v.drawString(300-pos.x-5,pos.y,
		"Leave",
		V_SNAPTORIGHT|V_SNAPTOTOP|V_YELLOWMAP|V_ALLOWLOWERCASE,
		"right"
	)
	
	--draw title
	v.drawString(pos.x,pos.y,
		page.title.."\x80 ("..tostring(menu.page+1).."/"..tostring(#CONK_MENU.entries+1)..")",
		V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP|V_ALLOWLOWERCASE,
		"left"
	)
	
	/*
	local doscroll = false
	local hinty = greenToReal(v,
	if (pos.y*FU+10*FU*#page.text) 
	
	end
	*/
	
	--the TEXT.
	for i = 1,#page.text
		shakex,shakey = happyshakelol(v,i)
		local txtlength = 0
		v.drawString(pos.x*FU+shakex, pos.y*FU+10*FU*i+shakey,
			page.text[i],
			V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE,
			"thin-fixed"
		)
		txtlength = v.stringWidth(page.text[i],V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE,"thin")*FU
		if (page.values ~= nil)
		and (#page.values)
		and (page.values[i] ~= nil)
			local value = '\x85???'
			
			--get the table so we can get our value
			if (type(page.values[i]) == "string")
				local table = TAKIS_NET
				if page.table == "takis.io"
					table = takis.io
				elseif page.table == "takis"
					table = takis
				elseif page.table == "player"
					table = p
				elseif page.table == "_G"
					table = _G
				elseif page.table ~= nil
					table = p[page.table]
				end
				value = tostring(table[(page.values[i])])
			else
				value = tostring(page.values[i])
			end
			
			v.drawString(pos.x*FU+txtlength+shakex,
				pos.y*FU+10*FU*i+shakey,
				": \x82"..value,
				V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE,
				"thin-fixed"
			)
		end
	end
	
	if (page.hints ~= nil)
	and (#page.hints)
		if (page.hints[menu.y+1] ~= nil)
			shakex,shakey = happyshakelol(v,menu.y+1,true)
			v.drawString(pos.x*FU+shakex, (200-pos.y)*FU-10*FU+shakey,
				page.hints[menu.y+1],
				V_GRAYMAP|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_ALLOWLOWERCASE,
				"thin-fixed"
			)
		end
	end
	
	local hinttrans = 0
	if menu.hintfade > 0
		if menu.hintfade > (3*TR+9)
			hinttrans = (menu.hintfade-(3*TR+9))<<V_ALPHASHIFT
		end
		if menu.hintfade < 10
			hinttrans = (10-menu.hintfade)<<V_ALPHASHIFT
		end
		shakex,shakey = happyshakelol(v,menu.y+1,true)
		v.drawString(pos.x*FU+shakex, ((200-pos.y)*FU)-42*FU+shakey,
			"[C1] - Exit",
			V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_GRAYMAP|V_RETURN8|V_ALLOWLOWERCASE|hinttrans,
			"thin-fixed"
		)
		shakex,shakey = happyshakelol(v,menu.y+1,true)
		v.drawString(pos.x*FU+shakex, ((200-pos.y)*FU)-34*FU+shakey,
			"[Jump] - Select",
			V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_GRAYMAP|V_RETURN8|V_ALLOWLOWERCASE|hinttrans,
			"thin-fixed"
		)
		shakex,shakey = happyshakelol(v,menu.y+1,true)
		v.drawString(pos.x*FU+shakex, ((200-pos.y)*FU)-26*FU+shakey,
			"[Up/Down] - Move Cursor",
			V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_GRAYMAP|V_RETURN8|V_ALLOWLOWERCASE|hinttrans,
			"thin-fixed"
		)
		shakex,shakey = happyshakelol(v,menu.y+1,true)
		v.drawString(pos.x*FU+shakex, ((200-pos.y)*FU)-18*FU+shakey,
			"[Left/Right] - Flip page",
			V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_GRAYMAP|V_RETURN8|V_ALLOWLOWERCASE|hinttrans,
			"thin-fixed"
		)
			
	end
	
end
hud.add(drawcosmenu)